/* LIFECALC.H: Dies ist ein Teil des Headers zu LIFE.C */
/* Erlaeuterungen finden sich in Lifecalc.doc */

#define ON  1
#define OFF 0

#define DEBUG ON /* ON fuer Ausgabe von Statusinfos, OFF = keine Ausgabe */

typedef	unsigned char	BufferType;

extern int		BfreeMemory;  	/* wird von Init u.a. benutzt */
extern BufferType	*BFieldBaseAddress;     /* Basisadresse des Zellenfeldes */
extern BufferType	*BFieldBufferAddress;	/* Pufferadresse zwecks Berechnung */
extern BufferType	*BFieldCurrentAddress;	/* Adresse des aktuellen Feldes */
extern BufferType	*BFieldAddress;		/* Adresse des Arbeitsfeldes, d.h.
					der 2. Zeile */

extern int		BFieldWidth;	/* Breite des Zellenfeldes in Bytes */
extern int		BFieldHeight;	/* Hoehe d.Zf. in Zeilen */
extern int		BFieldSize;		/* Gesamtgroesse des Zellfeldes in Bytes */
extern int		BSlaveID;		/* ID des Slaveprozesses */
extern int		BDebugID;		/* ID des Prozesses, der Debugs ausspucken
					soll */

/* Regeln: */
extern int		BRuleBirthMin;
extern int		BRuleBirthMax;
extern int		BRuleSurviveMin;
extern int		BRuleSurviveMax;	/* eigentlich 2, aber aequivalent und schneller */

int	BSet(void);
void	BEnd(void);
int	BCalc(void);
void	BSetDebugID(int id);
void	BSetSlaveID(int id);
void	BSetRules(int smin,int smax,int bmin,int bmax);

