#include <stdio.h>
#include <memory.h>
#include <stdlib.h>

#define SUN		/* Bytekonvertierung an (s. SunModify) */

typedef struct
{
	int	x,y;
} vec2;
typedef struct
{
	int	x,y,z;
} vec3;
typedef unsigned char 	playfield[20][20][20];
typedef unsigned char	ScreenArray[80][480];
typedef unsigned char	Byte;

vec2	p2d[8];
vec3    p3d[8];
float   xoff,yoff,zoom;
playfield    life,newlife;
Byte    code[4];
ScreenArray  *frames[14];
ScreenArray  *screen[2];
int	xpos,ypos,eb,dim;
float   kx,ky,kz;
ScreenArray *BaseField;

int byteoff(int x,int y)
{
  return((80 * y) + (x / 8));
}

unsigned char  pattern[4][8] =
	    {  {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
	       {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff},
	       {0x55,0xaa,0x55,0xaa,0x55,0xaa,0x55,0xaa},
	       {0x88,0x00,0x22,0x00,0x88,0x00,0x22,0x00}  };

void	SunModify(unsigned char *bf)
{		/* Spiegelt ein Byte (Hi2LowEndian) */
Byte bp;
Byte Mask1,Mask2;
int t1,t2,r;

	for(t1=0;t1<80;t1++){
	for(t2=0;t2<480;t2++)
	{
#if 0
		Mask1 = 0x01;
		Mask2 = 0x80;
		bp    = 0;
		for(r=0;r<8;r++)
		{
			if(*bf & Mask2)
				bp = bp | Mask1;
			Mask1 <<= 1;
			Mask2 >>= 1;
		}
		*bf = bp;
		bf++;
#else
		/*
		 * Eine etwas schnellere Version.
		 * Kay. 24.5.95
		 */
		bp = *bf;
		bp = ((bp & 0x0f) << 4) | ((bp & 0xf0) >> 4);
		bp = ((bp & 0x33) << 2) | ((bp & 0xcc) >> 2);
		bp = ((bp & 0x55) << 1) | ((bp & 0xaa) >> 1);
		*bf++ = bp;
#endif
	}} /* doppelte For-Schleife (int <= 32XXX) */
}

void bitblt_mem2screen(unsigned char *ba)
{
	SunModify(ba);
	/* RX aufrufen */
	ShowBitmap(ba,640,480,0,0);
	FlushBitmap();
}

unsigned char getpattern(int y,int i)
{
  return(pattern[i][y%8]);
}

Byte	xstab[8] = {0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f,0xff};
Byte	xetab[8] = {0xff,0xfe,0xfc,0xf8,0xf0,0xe0,0xc0,0x80};

void hline(int xs,int xe,int y,int idx)
{
int  xsoff,xeoff,xsbit,xebit,temp;
Byte  xsmask,xemask,mask,pattern;
Byte *adresse;

  pattern = getpattern(y,idx);
  if (xs>xe)
  {
    temp=xs; xs=xe; xe=temp;
  }
  xsoff=byteoff(xs,y);
  xeoff=byteoff(xe,y);
  xsbit=7-(xs%8);
  xebit=7-(xe%8);
  xsmask=xstab[xsbit];
  xemask=xetab[xebit];
  if (xsoff==xeoff)
  {
    mask = xsmask & xemask;
/*    mem[$b000:xsoff]:=(not mask) and mem[$b000:xsoff] or (mask and pattern);*/
   adresse = (Byte *) BaseField+xsoff;
   *adresse=(((~mask) & *adresse) | (mask & pattern));
  }
  else
  {
/*    mem[$b000:xsoff]:=(not xsmask) and mem[$b000:xsoff] or (xsmask and pattern);*/
    adresse = (Byte *) BaseField+xsoff;	
    *adresse=(((~xsmask) & *adresse) | (xsmask & pattern));
    xsoff++;
    while (xsoff<xeoff)
    {
/*      mem[$b000:xsoff]:=pattern;*/
      adresse = (Byte *) BaseField + xsoff;
      *adresse=pattern;
      xsoff++;
    }
/*    mem[$b000:xeoff]:=(not xemask) and mem[$b000:xeoff] or (xemask and pattern);*/
    adresse = (Byte *) BaseField+xeoff;
    *adresse=(((~xemask) & *adresse) | (xemask & pattern));
  }
}

int filltab[348][2];

void contour_(int xs,int ys,int xe,int ye)
{
int  dx,xm,ym;

  dx=abs(ye-ys);
  if (dx>1)
  {
    xm=(xs+xe) / 2;
    ym=(ys+ye) / 2;
    if (filltab[ym][0]<0)
	filltab[ym][0]=xm;
    else filltab[ym][1]=xm;
    contour_(xs,ys,xm,ym);
    contour_(xm,ym,xe,ye);
  }
}

void contour(int xs,int ys,int xe,int ye)
{
  contour_(xs,ys,xe,ye);
  if (filltab[ys][0]<0)
	filltab[ys][0]=xs;
  else filltab[ys][1]=xs;
}

void fill_4(int x1,int y1,int x2,int y2,int x3,int y3,int x4,int y4,int pattern)
{
int y;

  for(y=0;y<348;y++)
  {
    filltab[y][0]=-1;
    filltab[y][1]=-1;
  }
  contour(x1,y1,x2,y2);
  contour(x2,y2,x3,y3);
  contour(x3,y3,x4,y4);
  contour(x4,y4,x1,y1);
  y=0;
  do
  {
    if (filltab[y][0]>-1)
    {
      if (filltab[y][1]<0)
	 filltab[y][1]=filltab[y][0];
      hline(filltab[y][0],filltab[y][1],y,pattern);
    }
    y++;
  } while(y<348);
}

/*{******}*/

float  off[8][3] =
	{  {-1,0,-1},  {0,0,-2},
	   {1,0,-1},   {-1,-1.41,-1},
	   {0,-1.41,-2}, {1,-1.41,-1},
	   {0,-1.41,0},{0,0,0}  };

void makecube(float sx,float sy,float sz,float s)
{
int i;

  for(i=0;i<8;i++)
  {
      p3d[i].x = sx + off[i][0] * s;
      p3d[i].y = sy + off[i][1] * s;
      p3d[i].z = sz + off[i][2] * s;
  }
}

void projcube()
{
int i;

  for(i=0;i<8;i++)
  {
    p2d[i].x=(int) ((p3d[i].x*zoom/p3d[i].z)*1.5+xoff);  /*{===}*/
    p2d[i].y=(int) ((p3d[i].y*zoom/p3d[i].z)+yoff);
  }
}

void offset(float sx,float sy,float sz,float s)
{
  xoff=320-sx/sz*zoom;
  yoff=110-(sy-0.5*s)/sz*zoom;
}

void drawcube()
{
  fill_4(p2d[0].x,p2d[0].y,p2d[1].x,p2d[1].y,p2d[4].x,p2d[4].y,p2d[3].x,p2d[3].y,1);
  fill_4(p2d[1].x,p2d[1].y,p2d[2].x,p2d[2].y,p2d[5].x,p2d[5].y,p2d[4].x,p2d[4].y,3);
  fill_4(p2d[3].x,p2d[3].y,p2d[4].x,p2d[4].y,p2d[5].x,p2d[5].y,p2d[6].x,p2d[6].y,2);
}

void cube(float x,float y,float z,float s)
{
  makecube(x,y,z,s);
  projcube();
  drawcube();
/*  bitblt_mem2screen(BaseField);*/
}
/*BLOCK1*/
void clearlife()
{
int i,j,k;

  for(i=0;i<=dim;i++)
    for(j=0;j<=dim;j++)
      for(k=0;k<=dim;k++)
	life[i][j][k]=0;
}

void randomlife()
{
int i,j,k;
int    s;

  do
  {
    fprintf(stderr,"\nWieviel Prozent Leben : ");
    fflush(stderr);
    scanf("%d",&i);
  } while(!((i>0) && (i<100)));
  s = i;
  for(i=0;i<=dim;i++)
    for(j=0;j<=dim;j++)
      for(k=0;k<=dim;k++)
	if (rand()%101<=s)
		life[i][j][k]=1;
	else life[i][j][k]=0;
}

int warten = 1;

/*#include "./life3d/block1.inc"*/
#include "./life3d/block2.inc"
/*
void main(void)
{
int steps;

	grafikmodus(17);
	BaseField = malloc(sizeof(ScreenArray));
	memset(BaseField,0,80*480);
	kx = 0;
	ky = 600;
	kz = 1400;
	zoom = 500;
	offset(kx,ky,kz,300);
	cube(kx,ky,kz,300);
	bitblt_mem2screen(BaseField);
	getch();
	dim = 8;
	code[0]=4;
	code[1]=5;
	code[2]=5;
	code[3]=5;
	printf("\nDim(%2d) ",dim);
	randomlife();
	printf("\nSchritte: ");
	scanf("%d",&steps);
	printf("\nWarten (0=nein,1=ja) ");
	scanf("%d",&warten);
	runlife(kx,ky,kz,300,steps);
	grafikmodus(3);
}
*/

int Start3D(int steps)
{

	BaseField = malloc(sizeof(ScreenArray));
	memset(BaseField,0,80*480);
	kx = 0;
	ky = 600;
	kz = 1400;
	zoom = 500;
	offset(kx,ky,kz,300);
	cube(kx,ky,kz,300);
	bitblt_mem2screen((unsigned char *) BaseField);
	getchar();
	dim = 8;
	code[0]=4;
	code[1]=5;
	code[2]=5;
	code[3]=5;
	fprintf(stderr,"\nDim(%2d) ",dim);
	fflush(stderr);
	randomlife();
/*	printf("\nSchritte: ");
	scanf("%d",&steps);
*/
/*	fprintf(stderr,"\nWarten (0=nein,1=ja) ");
	fflush(stderr);
	scanf("%d",&warten);
*/	warten = 0;
	runlife(kx,ky,kz,300,steps);
	
	return(0);
}

